#!/usr/bin/env python
import urllib2,gzip
from StringIO import StringIO
import json
import MySQLdb
import sys
import time

if len(sys.argv)==1:
    print "usage: gettask getlist|gettasks"
    sys.exit(0)
        
cnx = MySQLdb.connect('*******','******','********','******',port=47104)
cursor = cnx.cursor()
        
if sys.argv[1]=='getlist':
    request = urllib2.Request("http://2016sv.icfpcontest.org/api/snapshot/list", headers={'X-API-Key': '45-04bd504a84d1c81f9545bcc3076c3323','Accept-Encoding': 'gzip'})
    contents = urllib2.urlopen(request)


    buf = StringIO( contents.read())
    f = gzip.GzipFile(fileobj=buf)
    data = f.read()
    data=json.loads(data)


    time.sleep(1);
    request = urllib2.Request("http://2016sv.icfpcontest.org/api/blob/"+data['snapshots'][-1]['snapshot_hash'], headers={'X-API-Key': '45-04bd504a84d1c81f9545bcc3076c3323','Accept-Encoding': 'gzip'})
    contents = urllib2.urlopen(request)


    buf = StringIO( contents.read())
    f = gzip.GzipFile(fileobj=buf)
    data = f.read()
    data=json.loads(data)
    for i in data['problems']:
        cursor.execute("""select id from problems where hash="%s" """%i["problem_spec_hash"])
        p=cursor.fetchall()
        if not p:
            cursor.execute("""insert into problems(id,problem_size,solution_size,hash) values (%s,%s,%s,"%s")"""% (i['problem_id'],i['problem_size'],i['solution_size'],i['problem_spec_hash']))
            cnx.commit();

elif sys.argv[1]=="gettasks":
    cursor.execute("""select id,hash from problems where task is null """);
    for i in cursor.fetchall():
        print "getting",i[0],i[1]
        request = urllib2.Request("http://2016sv.icfpcontest.org/api/blob/"+i[1], headers={'X-API-Key': '45-04bd504a84d1c81f9545bcc3076c3323','Accept-Encoding': 'gzip'})
        contents = urllib2.urlopen(request)
        buf = StringIO( contents.read())
        f = gzip.GzipFile(fileobj=buf)
        data = f.read()
        cursor.execute("""update problems set task="%s" where hash="%s" """%(data,i[1]))
        cnx.commit()
        time.sleep(1.5)
    
    